Public Class HomeController
    Inherits System.Web.Mvc.Controller

    Private _db As New MoviesDBEntities()


    '
    ' GET: /Home/


    Function Index() As ActionResult
        Return View(_db.MovieSet.ToList())
    End Function

    '
    ' GET: /Home/Details/5

    Function Details(ByVal id As Integer) As ActionResult
        Return View()
    End Function

    Function Create() As ActionResult
        Return View()
    End Function

    <AcceptVerbs(HttpVerbs.Post)> _
    Function Create(<Bind(Exclude:="Id")> ByVal movieToCreate As Movie) As ActionResult

        If Not ModelState.IsValid Then
            Return View()
        End If

        _db.AddToMovieSet(movieToCreate)
        _db.SaveChanges()

        Return RedirectToAction("Index")
    End Function


    Function Edit(ByVal id As Integer) As ActionResult
        Dim movieToEdit = (From m In _db.MovieSet _
                       Where m.Id = id _
                       Select m).First()

        Return View(movieToEdit)
    End Function


    <AcceptVerbs(HttpVerbs.Post)> _
    Function Edit(ByVal movieToEdit As Movie) As ActionResult

        Dim originalMovie = (From m In _db.MovieSet _
                   Where m.Id = movieToEdit.Id _
                   Select m).First()

        If Not ModelState.IsValid Then
            Return View(originalMovie)
        End If


        _db.ApplyPropertyChanges(originalMovie.EntityKey.EntitySetName, movieToEdit)
        _db.SaveChanges()

        Return RedirectToAction("Index")
    End Function



End Class
